# Generated by the Protocol Buffers compiler. DO NOT EDIT!
# source: backup.proto
# plugin: grpclib.plugin.main
import abc
import typing

import grpclib.const
import grpclib.client
if typing.TYPE_CHECKING:
    import grpclib.server

from . import common_pb2
from . import vmware_pb2
from . import hyperv_pb2
from . import job_pb2
from . import storage_pb2
from . import hardware_pb2
from . import backup_pb2


class BackupBase(abc.ABC):

    @abc.abstractmethod
    async def Start(self, stream: 'grpclib.server.Stream[backup_pb2.StartRequest, backup_pb2.StartResponse]') -> None:
        pass

    @abc.abstractmethod
    async def List(self, stream: 'grpclib.server.Stream[backup_pb2.ListRequest, backup_pb2.ListResponse]') -> None:
        pass

    @abc.abstractmethod
    async def Query(self, stream: 'grpclib.server.Stream[backup_pb2.QueryRequest, backup_pb2.QueryResponse]') -> None:
        pass

    @abc.abstractmethod
    async def Update(self, stream: 'grpclib.server.Stream[backup_pb2.UpdateRequest, backup_pb2.UpdateResponse]') -> None:
        pass

    @abc.abstractmethod
    async def Cancel(self, stream: 'grpclib.server.Stream[backup_pb2.CancelRequest, backup_pb2.CancelResponse]') -> None:
        pass

    @abc.abstractmethod
    async def GetStatus(self, stream: 'grpclib.server.Stream[backup_pb2.GetStatusRequest, backup_pb2.GetStatusResponse]') -> None:
        pass

    @abc.abstractmethod
    async def GetConfig(self, stream: 'grpclib.server.Stream[backup_pb2.GetConfigRequest, backup_pb2.GetConfigResponse]') -> None:
        pass

    @abc.abstractmethod
    async def SetConfig(self, stream: 'grpclib.server.Stream[backup_pb2.SetConfigRequest, backup_pb2.SetConfigResponse]') -> None:
        pass

    @abc.abstractmethod
    async def Check(self, stream: 'grpclib.server.Stream[common_pb2.HealthCheckRequest, common_pb2.HealthCheckResponse]') -> None:
        pass

    def __mapping__(self) -> typing.Dict[str, grpclib.const.Handler]:
        return {
            '/stc.proto.backup.Backup/Start': grpclib.const.Handler(
                self.Start,
                grpclib.const.Cardinality.UNARY_UNARY,
                backup_pb2.StartRequest,
                backup_pb2.StartResponse,
            ),
            '/stc.proto.backup.Backup/List': grpclib.const.Handler(
                self.List,
                grpclib.const.Cardinality.UNARY_UNARY,
                backup_pb2.ListRequest,
                backup_pb2.ListResponse,
            ),
            '/stc.proto.backup.Backup/Query': grpclib.const.Handler(
                self.Query,
                grpclib.const.Cardinality.UNARY_UNARY,
                backup_pb2.QueryRequest,
                backup_pb2.QueryResponse,
            ),
            '/stc.proto.backup.Backup/Update': grpclib.const.Handler(
                self.Update,
                grpclib.const.Cardinality.UNARY_UNARY,
                backup_pb2.UpdateRequest,
                backup_pb2.UpdateResponse,
            ),
            '/stc.proto.backup.Backup/Cancel': grpclib.const.Handler(
                self.Cancel,
                grpclib.const.Cardinality.UNARY_UNARY,
                backup_pb2.CancelRequest,
                backup_pb2.CancelResponse,
            ),
            '/stc.proto.backup.Backup/GetStatus': grpclib.const.Handler(
                self.GetStatus,
                grpclib.const.Cardinality.UNARY_UNARY,
                backup_pb2.GetStatusRequest,
                backup_pb2.GetStatusResponse,
            ),
            '/stc.proto.backup.Backup/GetConfig': grpclib.const.Handler(
                self.GetConfig,
                grpclib.const.Cardinality.UNARY_UNARY,
                backup_pb2.GetConfigRequest,
                backup_pb2.GetConfigResponse,
            ),
            '/stc.proto.backup.Backup/SetConfig': grpclib.const.Handler(
                self.SetConfig,
                grpclib.const.Cardinality.UNARY_UNARY,
                backup_pb2.SetConfigRequest,
                backup_pb2.SetConfigResponse,
            ),
            '/stc.proto.backup.Backup/Check': grpclib.const.Handler(
                self.Check,
                grpclib.const.Cardinality.UNARY_UNARY,
                common_pb2.HealthCheckRequest,
                common_pb2.HealthCheckResponse,
            ),
        }


class BackupStub:

    def __init__(self, channel: grpclib.client.Channel) -> None:
        self.Start = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.backup.Backup/Start',
            backup_pb2.StartRequest,
            backup_pb2.StartResponse,
        )
        self.List = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.backup.Backup/List',
            backup_pb2.ListRequest,
            backup_pb2.ListResponse,
        )
        self.Query = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.backup.Backup/Query',
            backup_pb2.QueryRequest,
            backup_pb2.QueryResponse,
        )
        self.Update = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.backup.Backup/Update',
            backup_pb2.UpdateRequest,
            backup_pb2.UpdateResponse,
        )
        self.Cancel = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.backup.Backup/Cancel',
            backup_pb2.CancelRequest,
            backup_pb2.CancelResponse,
        )
        self.GetStatus = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.backup.Backup/GetStatus',
            backup_pb2.GetStatusRequest,
            backup_pb2.GetStatusResponse,
        )
        self.GetConfig = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.backup.Backup/GetConfig',
            backup_pb2.GetConfigRequest,
            backup_pb2.GetConfigResponse,
        )
        self.SetConfig = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.backup.Backup/SetConfig',
            backup_pb2.SetConfigRequest,
            backup_pb2.SetConfigResponse,
        )
        self.Check = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.backup.Backup/Check',
            common_pb2.HealthCheckRequest,
            common_pb2.HealthCheckResponse,
        )
