# Generated by the Protocol Buffers compiler. DO NOT EDIT!
# source: hyperv.proto
# plugin: grpclib.plugin.main
import abc
import typing

import grpclib.const
import grpclib.client
if typing.TYPE_CHECKING:
    import grpclib.server

from . import common_pb2
from . import hardware_pb2
from . import hyperv_pb2


class HyperVBase(abc.ABC):

    @abc.abstractmethod
    async def VerifyConnection(self, stream: 'grpclib.server.Stream[hyperv_pb2.VerifyConnectionRequest, hyperv_pb2.VerifyConnectionResponse]') -> None:
        pass

    @abc.abstractmethod
    async def ListVMs(self, stream: 'grpclib.server.Stream[hyperv_pb2.ListVMsRequest, hyperv_pb2.ListVMsResponse]') -> None:
        pass

    @abc.abstractmethod
    async def CreateVM(self, stream: 'grpclib.server.Stream[hyperv_pb2.CreateVMRequest, hyperv_pb2.CreateVMResponse]') -> None:
        pass

    @abc.abstractmethod
    async def PowerOnVM(self, stream: 'grpclib.server.Stream[hyperv_pb2.PowerOnVMRequest, hyperv_pb2.PowerOnVMResponse]') -> None:
        pass

    @abc.abstractmethod
    async def SnapshotVM(self, stream: 'grpclib.server.Stream[hyperv_pb2.SnapshotVMRequest, hyperv_pb2.SnapshotVMResponse]') -> None:
        pass

    @abc.abstractmethod
    async def GetConfig(self, stream: 'grpclib.server.Stream[hyperv_pb2.GetConfigRequest, hyperv_pb2.GetConfigResponse]') -> None:
        pass

    @abc.abstractmethod
    async def AttachStorage(self, stream: 'grpclib.server.Stream[hyperv_pb2.AttachStorageRequest, hyperv_pb2.AttachStorageResponse]') -> None:
        pass

    @abc.abstractmethod
    async def ListVirtualSwitches(self, stream: 'grpclib.server.Stream[hyperv_pb2.ListVirtualSwitchesRequest, hyperv_pb2.ListVirtualSwitchesResponse]') -> None:
        pass

    @abc.abstractmethod
    async def Refresh(self, stream: 'grpclib.server.Stream[hyperv_pb2.RefreshRequest, hyperv_pb2.RefreshResponse]') -> None:
        pass

    def __mapping__(self) -> typing.Dict[str, grpclib.const.Handler]:
        return {
            '/stc.proto.hyperv.HyperV/VerifyConnection': grpclib.const.Handler(
                self.VerifyConnection,
                grpclib.const.Cardinality.UNARY_UNARY,
                hyperv_pb2.VerifyConnectionRequest,
                hyperv_pb2.VerifyConnectionResponse,
            ),
            '/stc.proto.hyperv.HyperV/ListVMs': grpclib.const.Handler(
                self.ListVMs,
                grpclib.const.Cardinality.UNARY_UNARY,
                hyperv_pb2.ListVMsRequest,
                hyperv_pb2.ListVMsResponse,
            ),
            '/stc.proto.hyperv.HyperV/CreateVM': grpclib.const.Handler(
                self.CreateVM,
                grpclib.const.Cardinality.UNARY_UNARY,
                hyperv_pb2.CreateVMRequest,
                hyperv_pb2.CreateVMResponse,
            ),
            '/stc.proto.hyperv.HyperV/PowerOnVM': grpclib.const.Handler(
                self.PowerOnVM,
                grpclib.const.Cardinality.UNARY_UNARY,
                hyperv_pb2.PowerOnVMRequest,
                hyperv_pb2.PowerOnVMResponse,
            ),
            '/stc.proto.hyperv.HyperV/SnapshotVM': grpclib.const.Handler(
                self.SnapshotVM,
                grpclib.const.Cardinality.UNARY_UNARY,
                hyperv_pb2.SnapshotVMRequest,
                hyperv_pb2.SnapshotVMResponse,
            ),
            '/stc.proto.hyperv.HyperV/GetConfig': grpclib.const.Handler(
                self.GetConfig,
                grpclib.const.Cardinality.UNARY_UNARY,
                hyperv_pb2.GetConfigRequest,
                hyperv_pb2.GetConfigResponse,
            ),
            '/stc.proto.hyperv.HyperV/AttachStorage': grpclib.const.Handler(
                self.AttachStorage,
                grpclib.const.Cardinality.UNARY_UNARY,
                hyperv_pb2.AttachStorageRequest,
                hyperv_pb2.AttachStorageResponse,
            ),
            '/stc.proto.hyperv.HyperV/ListVirtualSwitches': grpclib.const.Handler(
                self.ListVirtualSwitches,
                grpclib.const.Cardinality.UNARY_UNARY,
                hyperv_pb2.ListVirtualSwitchesRequest,
                hyperv_pb2.ListVirtualSwitchesResponse,
            ),
            '/stc.proto.hyperv.HyperV/Refresh': grpclib.const.Handler(
                self.Refresh,
                grpclib.const.Cardinality.UNARY_UNARY,
                hyperv_pb2.RefreshRequest,
                hyperv_pb2.RefreshResponse,
            ),
        }


class HyperVStub:

    def __init__(self, channel: grpclib.client.Channel) -> None:
        self.VerifyConnection = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.hyperv.HyperV/VerifyConnection',
            hyperv_pb2.VerifyConnectionRequest,
            hyperv_pb2.VerifyConnectionResponse,
        )
        self.ListVMs = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.hyperv.HyperV/ListVMs',
            hyperv_pb2.ListVMsRequest,
            hyperv_pb2.ListVMsResponse,
        )
        self.CreateVM = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.hyperv.HyperV/CreateVM',
            hyperv_pb2.CreateVMRequest,
            hyperv_pb2.CreateVMResponse,
        )
        self.PowerOnVM = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.hyperv.HyperV/PowerOnVM',
            hyperv_pb2.PowerOnVMRequest,
            hyperv_pb2.PowerOnVMResponse,
        )
        self.SnapshotVM = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.hyperv.HyperV/SnapshotVM',
            hyperv_pb2.SnapshotVMRequest,
            hyperv_pb2.SnapshotVMResponse,
        )
        self.GetConfig = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.hyperv.HyperV/GetConfig',
            hyperv_pb2.GetConfigRequest,
            hyperv_pb2.GetConfigResponse,
        )
        self.AttachStorage = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.hyperv.HyperV/AttachStorage',
            hyperv_pb2.AttachStorageRequest,
            hyperv_pb2.AttachStorageResponse,
        )
        self.ListVirtualSwitches = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.hyperv.HyperV/ListVirtualSwitches',
            hyperv_pb2.ListVirtualSwitchesRequest,
            hyperv_pb2.ListVirtualSwitchesResponse,
        )
        self.Refresh = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.hyperv.HyperV/Refresh',
            hyperv_pb2.RefreshRequest,
            hyperv_pb2.RefreshResponse,
        )
