# Generated by the Protocol Buffers compiler. DO NOT EDIT!
# source: machine.proto
# plugin: grpclib.plugin.main
import abc
import typing

import grpclib.const
import grpclib.client
if typing.TYPE_CHECKING:
    import grpclib.server

from . import common_pb2
from . import super_pb2
from . import hardware_pb2
from . import machine_pb2


class MachineBase(abc.ABC):

    @abc.abstractmethod
    async def ListDisks(self, stream: 'grpclib.server.Stream[machine_pb2.ListDisksRequest, machine_pb2.ListDisksResponse]') -> None:
        pass

    @abc.abstractmethod
    async def GetSupportBundle(self, stream: 'grpclib.server.Stream[machine_pb2.GetSupportBundleRequest, machine_pb2.GetSupportBundleResponse]') -> None:
        pass

    @abc.abstractmethod
    async def CreateSupportBundle(self, stream: 'grpclib.server.Stream[machine_pb2.CreateSupportBundleRequest, machine_pb2.CreateSupportBundleResponse]') -> None:
        pass

    @abc.abstractmethod
    async def ProductVersion(self, stream: 'grpclib.server.Stream[machine_pb2.ProductVersionRequest, machine_pb2.ProductVersionResponse]') -> None:
        pass

    @abc.abstractmethod
    async def Decommission(self, stream: 'grpclib.server.Stream[machine_pb2.DecommissionRequest, machine_pb2.DecommissionResponse]') -> None:
        pass

    @abc.abstractmethod
    async def GetStatus(self, stream: 'grpclib.server.Stream[machine_pb2.GetStatusRequest, machine_pb2.GetStatusResponse]') -> None:
        pass

    @abc.abstractmethod
    async def GetConfig(self, stream: 'grpclib.server.Stream[machine_pb2.GetConfigRequest, machine_pb2.GetConfigResponse]') -> None:
        pass

    @abc.abstractmethod
    async def SetConfig(self, stream: 'grpclib.server.Stream[machine_pb2.SetConfigRequest, machine_pb2.SetConfigResponse]') -> None:
        pass

    @abc.abstractmethod
    async def Check(self, stream: 'grpclib.server.Stream[common_pb2.HealthCheckRequest, common_pb2.HealthCheckResponse]') -> None:
        pass

    @abc.abstractmethod
    async def CheckUpdates(self, stream: 'grpclib.server.Stream[machine_pb2.CheckUpdatesRequest, machine_pb2.CheckUpdatesResponse]') -> None:
        pass

    @abc.abstractmethod
    async def DownloadUpdates(self, stream: 'grpclib.server.Stream[machine_pb2.DownloadUpdatesRequest, machine_pb2.DownloadUpdatesResponse]') -> None:
        pass

    @abc.abstractmethod
    async def ApplyUpdates(self, stream: 'grpclib.server.Stream[machine_pb2.ApplyUpdatesRequest, machine_pb2.ApplyUpdatesResponse]') -> None:
        pass

    @abc.abstractmethod
    async def AssignSiteLeader(self, stream: 'grpclib.server.Stream[machine_pb2.AssignSiteLeaderRequest, machine_pb2.AssignSiteLeaderResponse]') -> None:
        pass

    @abc.abstractmethod
    async def SystemShutdown(self, stream: 'grpclib.server.Stream[super_pb2.SystemShutdownRequest, super_pb2.SystemShutdownResponse]') -> None:
        pass

    @abc.abstractmethod
    async def Refresh(self, stream: 'grpclib.server.Stream[machine_pb2.RefreshRequest, machine_pb2.RefreshResponse]') -> None:
        pass

    @abc.abstractmethod
    async def LogMemoryStart(self, stream: 'grpclib.server.Stream[machine_pb2.LogMemoryStartRequest, machine_pb2.LogMemoryStartResponse]') -> None:
        pass

    @abc.abstractmethod
    async def LogMemoryStop(self, stream: 'grpclib.server.Stream[machine_pb2.LogMemoryStopRequest, machine_pb2.LogMemoryStopResponse]') -> None:
        pass

    def __mapping__(self) -> typing.Dict[str, grpclib.const.Handler]:
        return {
            '/stc.proto.machine.Machine/ListDisks': grpclib.const.Handler(
                self.ListDisks,
                grpclib.const.Cardinality.UNARY_UNARY,
                machine_pb2.ListDisksRequest,
                machine_pb2.ListDisksResponse,
            ),
            '/stc.proto.machine.Machine/GetSupportBundle': grpclib.const.Handler(
                self.GetSupportBundle,
                grpclib.const.Cardinality.UNARY_STREAM,
                machine_pb2.GetSupportBundleRequest,
                machine_pb2.GetSupportBundleResponse,
            ),
            '/stc.proto.machine.Machine/CreateSupportBundle': grpclib.const.Handler(
                self.CreateSupportBundle,
                grpclib.const.Cardinality.UNARY_UNARY,
                machine_pb2.CreateSupportBundleRequest,
                machine_pb2.CreateSupportBundleResponse,
            ),
            '/stc.proto.machine.Machine/ProductVersion': grpclib.const.Handler(
                self.ProductVersion,
                grpclib.const.Cardinality.UNARY_UNARY,
                machine_pb2.ProductVersionRequest,
                machine_pb2.ProductVersionResponse,
            ),
            '/stc.proto.machine.Machine/Decommission': grpclib.const.Handler(
                self.Decommission,
                grpclib.const.Cardinality.UNARY_UNARY,
                machine_pb2.DecommissionRequest,
                machine_pb2.DecommissionResponse,
            ),
            '/stc.proto.machine.Machine/GetStatus': grpclib.const.Handler(
                self.GetStatus,
                grpclib.const.Cardinality.UNARY_UNARY,
                machine_pb2.GetStatusRequest,
                machine_pb2.GetStatusResponse,
            ),
            '/stc.proto.machine.Machine/GetConfig': grpclib.const.Handler(
                self.GetConfig,
                grpclib.const.Cardinality.UNARY_UNARY,
                machine_pb2.GetConfigRequest,
                machine_pb2.GetConfigResponse,
            ),
            '/stc.proto.machine.Machine/SetConfig': grpclib.const.Handler(
                self.SetConfig,
                grpclib.const.Cardinality.UNARY_UNARY,
                machine_pb2.SetConfigRequest,
                machine_pb2.SetConfigResponse,
            ),
            '/stc.proto.machine.Machine/Check': grpclib.const.Handler(
                self.Check,
                grpclib.const.Cardinality.UNARY_UNARY,
                common_pb2.HealthCheckRequest,
                common_pb2.HealthCheckResponse,
            ),
            '/stc.proto.machine.Machine/CheckUpdates': grpclib.const.Handler(
                self.CheckUpdates,
                grpclib.const.Cardinality.UNARY_UNARY,
                machine_pb2.CheckUpdatesRequest,
                machine_pb2.CheckUpdatesResponse,
            ),
            '/stc.proto.machine.Machine/DownloadUpdates': grpclib.const.Handler(
                self.DownloadUpdates,
                grpclib.const.Cardinality.UNARY_UNARY,
                machine_pb2.DownloadUpdatesRequest,
                machine_pb2.DownloadUpdatesResponse,
            ),
            '/stc.proto.machine.Machine/ApplyUpdates': grpclib.const.Handler(
                self.ApplyUpdates,
                grpclib.const.Cardinality.UNARY_UNARY,
                machine_pb2.ApplyUpdatesRequest,
                machine_pb2.ApplyUpdatesResponse,
            ),
            '/stc.proto.machine.Machine/AssignSiteLeader': grpclib.const.Handler(
                self.AssignSiteLeader,
                grpclib.const.Cardinality.UNARY_UNARY,
                machine_pb2.AssignSiteLeaderRequest,
                machine_pb2.AssignSiteLeaderResponse,
            ),
            '/stc.proto.machine.Machine/SystemShutdown': grpclib.const.Handler(
                self.SystemShutdown,
                grpclib.const.Cardinality.UNARY_UNARY,
                super_pb2.SystemShutdownRequest,
                super_pb2.SystemShutdownResponse,
            ),
            '/stc.proto.machine.Machine/Refresh': grpclib.const.Handler(
                self.Refresh,
                grpclib.const.Cardinality.UNARY_UNARY,
                machine_pb2.RefreshRequest,
                machine_pb2.RefreshResponse,
            ),
            '/stc.proto.machine.Machine/LogMemoryStart': grpclib.const.Handler(
                self.LogMemoryStart,
                grpclib.const.Cardinality.UNARY_UNARY,
                machine_pb2.LogMemoryStartRequest,
                machine_pb2.LogMemoryStartResponse,
            ),
            '/stc.proto.machine.Machine/LogMemoryStop': grpclib.const.Handler(
                self.LogMemoryStop,
                grpclib.const.Cardinality.UNARY_UNARY,
                machine_pb2.LogMemoryStopRequest,
                machine_pb2.LogMemoryStopResponse,
            ),
        }


class MachineStub:

    def __init__(self, channel: grpclib.client.Channel) -> None:
        self.ListDisks = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.machine.Machine/ListDisks',
            machine_pb2.ListDisksRequest,
            machine_pb2.ListDisksResponse,
        )
        self.GetSupportBundle = grpclib.client.UnaryStreamMethod(
            channel,
            '/stc.proto.machine.Machine/GetSupportBundle',
            machine_pb2.GetSupportBundleRequest,
            machine_pb2.GetSupportBundleResponse,
        )
        self.CreateSupportBundle = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.machine.Machine/CreateSupportBundle',
            machine_pb2.CreateSupportBundleRequest,
            machine_pb2.CreateSupportBundleResponse,
        )
        self.ProductVersion = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.machine.Machine/ProductVersion',
            machine_pb2.ProductVersionRequest,
            machine_pb2.ProductVersionResponse,
        )
        self.Decommission = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.machine.Machine/Decommission',
            machine_pb2.DecommissionRequest,
            machine_pb2.DecommissionResponse,
        )
        self.GetStatus = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.machine.Machine/GetStatus',
            machine_pb2.GetStatusRequest,
            machine_pb2.GetStatusResponse,
        )
        self.GetConfig = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.machine.Machine/GetConfig',
            machine_pb2.GetConfigRequest,
            machine_pb2.GetConfigResponse,
        )
        self.SetConfig = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.machine.Machine/SetConfig',
            machine_pb2.SetConfigRequest,
            machine_pb2.SetConfigResponse,
        )
        self.Check = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.machine.Machine/Check',
            common_pb2.HealthCheckRequest,
            common_pb2.HealthCheckResponse,
        )
        self.CheckUpdates = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.machine.Machine/CheckUpdates',
            machine_pb2.CheckUpdatesRequest,
            machine_pb2.CheckUpdatesResponse,
        )
        self.DownloadUpdates = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.machine.Machine/DownloadUpdates',
            machine_pb2.DownloadUpdatesRequest,
            machine_pb2.DownloadUpdatesResponse,
        )
        self.ApplyUpdates = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.machine.Machine/ApplyUpdates',
            machine_pb2.ApplyUpdatesRequest,
            machine_pb2.ApplyUpdatesResponse,
        )
        self.AssignSiteLeader = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.machine.Machine/AssignSiteLeader',
            machine_pb2.AssignSiteLeaderRequest,
            machine_pb2.AssignSiteLeaderResponse,
        )
        self.SystemShutdown = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.machine.Machine/SystemShutdown',
            super_pb2.SystemShutdownRequest,
            super_pb2.SystemShutdownResponse,
        )
        self.Refresh = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.machine.Machine/Refresh',
            machine_pb2.RefreshRequest,
            machine_pb2.RefreshResponse,
        )
        self.LogMemoryStart = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.machine.Machine/LogMemoryStart',
            machine_pb2.LogMemoryStartRequest,
            machine_pb2.LogMemoryStartResponse,
        )
        self.LogMemoryStop = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.machine.Machine/LogMemoryStop',
            machine_pb2.LogMemoryStopRequest,
            machine_pb2.LogMemoryStopResponse,
        )
