# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
import grpc

from . import protectionenvironment_pb2 as protectionenvironment__pb2


class ProtectionEnvironmentStub(object):
  """Add a new Azure protection environment

  Example flows:

  - Microsoft Azure -
  1 - AddEnvironment()
  2 - UpdateEnvironmentCredentials({ ..., appClientID })
  a) Expect a response with Device Code Flow information
  b) Prompt user for Device Code authorization steps
  3 - Poll GetEnvironmentStatus() while response is "pending"
  """

  def __init__(self, channel):
    """Constructor.

    Args:
      channel: A grpc.Channel.
    """
    self.AddEnvironment = channel.unary_unary(
        '/stc.proto.protectionenvironment.azure.ProtectionEnvironment/AddEnvironment',
        request_serializer=protectionenvironment__pb2.AddEnvironmentRequest.SerializeToString,
        response_deserializer=protectionenvironment__pb2.AddEnvironmentResponse.FromString,
        )
    self.RemoveEnvironment = channel.unary_unary(
        '/stc.proto.protectionenvironment.azure.ProtectionEnvironment/RemoveEnvironment',
        request_serializer=protectionenvironment__pb2.RemoveEnvironmentRequest.SerializeToString,
        response_deserializer=protectionenvironment__pb2.RemoveEnvironmentResponse.FromString,
        )
    self.UpdateEnvironment = channel.unary_unary(
        '/stc.proto.protectionenvironment.azure.ProtectionEnvironment/UpdateEnvironment',
        request_serializer=protectionenvironment__pb2.UpdateEnvironmentRequest.SerializeToString,
        response_deserializer=protectionenvironment__pb2.UpdateEnvironmentResponse.FromString,
        )
    self.ListEnvironments = channel.unary_unary(
        '/stc.proto.protectionenvironment.azure.ProtectionEnvironment/ListEnvironments',
        request_serializer=protectionenvironment__pb2.ListEnvironmentsRequest.SerializeToString,
        response_deserializer=protectionenvironment__pb2.ListEnvironmentsResponse.FromString,
        )
    self.ListContainers = channel.unary_stream(
        '/stc.proto.protectionenvironment.azure.ProtectionEnvironment/ListContainers',
        request_serializer=protectionenvironment__pb2.ListContainersRequest.SerializeToString,
        response_deserializer=protectionenvironment__pb2.ListContainersResponse.FromString,
        )
    self.UpdateEnvironmentCredentials = channel.unary_unary(
        '/stc.proto.protectionenvironment.azure.ProtectionEnvironment/UpdateEnvironmentCredentials',
        request_serializer=protectionenvironment__pb2.UpdateEnvironmentCredentialsRequest.SerializeToString,
        response_deserializer=protectionenvironment__pb2.UpdateEnvironmentCredentialsResponse.FromString,
        )
    self.GetEnvironmentStatus = channel.unary_unary(
        '/stc.proto.protectionenvironment.azure.ProtectionEnvironment/GetEnvironmentStatus',
        request_serializer=protectionenvironment__pb2.GetEnvironmentStatusRequest.SerializeToString,
        response_deserializer=protectionenvironment__pb2.GetEnvironmentStatusResponse.FromString,
        )
    self.UpdateEnvironmentMetadata = channel.unary_unary(
        '/stc.proto.protectionenvironment.azure.ProtectionEnvironment/UpdateEnvironmentMetadata',
        request_serializer=protectionenvironment__pb2.UpdateEnvironmentMetadataRequest.SerializeToString,
        response_deserializer=protectionenvironment__pb2.UpdateEnvironmentMetadataResponse.FromString,
        )
    self.GetEnvironmentMetadata = channel.unary_unary(
        '/stc.proto.protectionenvironment.azure.ProtectionEnvironment/GetEnvironmentMetadata',
        request_serializer=protectionenvironment__pb2.GetEnvironmentMetadataRequest.SerializeToString,
        response_deserializer=protectionenvironment__pb2.GetEnvironmentMetadataResponse.FromString,
        )
    self.GetExternalToken = channel.unary_unary(
        '/stc.proto.protectionenvironment.azure.ProtectionEnvironment/GetExternalToken',
        request_serializer=protectionenvironment__pb2.GetExternalTokenRequest.SerializeToString,
        response_deserializer=protectionenvironment__pb2.GetExternalTokenResponse.FromString,
        )
    self.ListResources = channel.unary_stream(
        '/stc.proto.protectionenvironment.azure.ProtectionEnvironment/ListResources',
        request_serializer=protectionenvironment__pb2.ListResourcesRequest.SerializeToString,
        response_deserializer=protectionenvironment__pb2.ListResourcesResponse.FromString,
        )
    self.AddStorage = channel.unary_stream(
        '/stc.proto.protectionenvironment.azure.ProtectionEnvironment/AddStorage',
        request_serializer=protectionenvironment__pb2.AddStorageRequest.SerializeToString,
        response_deserializer=protectionenvironment__pb2.AddStorageResponse.FromString,
        )
    self.ListStorage = channel.unary_stream(
        '/stc.proto.protectionenvironment.azure.ProtectionEnvironment/ListStorage',
        request_serializer=protectionenvironment__pb2.ListStorageRequest.SerializeToString,
        response_deserializer=protectionenvironment__pb2.ListStorageResponse.FromString,
        )


class ProtectionEnvironmentServicer(object):
  """Add a new Azure protection environment

  Example flows:

  - Microsoft Azure -
  1 - AddEnvironment()
  2 - UpdateEnvironmentCredentials({ ..., appClientID })
  a) Expect a response with Device Code Flow information
  b) Prompt user for Device Code authorization steps
  3 - Poll GetEnvironmentStatus() while response is "pending"
  """

  def AddEnvironment(self, request, context):
    """- VMware vSphere -
    1 - AddEnvironment({url, <tls_thumbprint>})
    a) If invalid cert, let user handle the situation
    b) Perhaps call AddEnvironment() again with updated thumbprint= to accept TLS cert
    2 - UpdateEnvironmentCredentials({username, password})

    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def RemoveEnvironment(self, request, context):
    """Remove an environment
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def UpdateEnvironment(self, request, context):
    """Update an environment
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def ListEnvironments(self, request, context):
    """List Environments
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def ListContainers(self, request, context):
    """List arbitrary containers. For Azure this is currently Subscriptions -> Resource Groups
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def UpdateEnvironmentCredentials(self, request, context):
    """Add/update environment credentails for an existing environment
    When using OAuth2Device, 'scope' will be defaulted if not supplied.
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def GetEnvironmentStatus(self, request, context):
    """Get the status of an environment
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def UpdateEnvironmentMetadata(self, request, context):
    """Add/Update/Remove metadata associated with an environment
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def GetEnvironmentMetadata(self, request, context):
    """Fetch metadata value(s) for an environment
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def GetExternalToken(self, request, context):
    """Fetch an external (and possibly opaque) token
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def ListResources(self, request, context):
    """:TODO: ListMachines() -> hardware.proto.
    If it's very expensive to get all the data, some combination of:
    - Basic information: MachineIdentifier
    - Use cache (DB) to allow flag of new vs all. Existing machines can be updated with e.g. UpdateMachineMetadata() with taking our ID mapping to extenral ID....
    ...additional calls returning existing machines have both IDs in MachineIdentifier.
    - Field mask for non-basic IDs.
    ...note that we also have an existing concept of a Refresh, so I think the Refresh API here makes sense. A one of "These machines" means they can gather information
    (new calls -> info and/or cache) and then post up the results as they are available. This is the mechanism we've already started using, so it make sense to continue

    List/enumerate external resources such as Azure subscriptions.

    Well known IDs:
    - 'subscrpitions': Returns Azure subscriptions for the account-associated tenant
    See also azure/consts.py::ExternalResources
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def AddStorage(self, request, context):
    """Add a new storage
    note: This API does *not* add a new Storage Node to Jarvis
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def ListStorage(self, request, context):
    """List Azure Storage Accounts
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')


def add_ProtectionEnvironmentServicer_to_server(servicer, server):
  rpc_method_handlers = {
      'AddEnvironment': grpc.unary_unary_rpc_method_handler(
          servicer.AddEnvironment,
          request_deserializer=protectionenvironment__pb2.AddEnvironmentRequest.FromString,
          response_serializer=protectionenvironment__pb2.AddEnvironmentResponse.SerializeToString,
      ),
      'RemoveEnvironment': grpc.unary_unary_rpc_method_handler(
          servicer.RemoveEnvironment,
          request_deserializer=protectionenvironment__pb2.RemoveEnvironmentRequest.FromString,
          response_serializer=protectionenvironment__pb2.RemoveEnvironmentResponse.SerializeToString,
      ),
      'UpdateEnvironment': grpc.unary_unary_rpc_method_handler(
          servicer.UpdateEnvironment,
          request_deserializer=protectionenvironment__pb2.UpdateEnvironmentRequest.FromString,
          response_serializer=protectionenvironment__pb2.UpdateEnvironmentResponse.SerializeToString,
      ),
      'ListEnvironments': grpc.unary_unary_rpc_method_handler(
          servicer.ListEnvironments,
          request_deserializer=protectionenvironment__pb2.ListEnvironmentsRequest.FromString,
          response_serializer=protectionenvironment__pb2.ListEnvironmentsResponse.SerializeToString,
      ),
      'ListContainers': grpc.unary_stream_rpc_method_handler(
          servicer.ListContainers,
          request_deserializer=protectionenvironment__pb2.ListContainersRequest.FromString,
          response_serializer=protectionenvironment__pb2.ListContainersResponse.SerializeToString,
      ),
      'UpdateEnvironmentCredentials': grpc.unary_unary_rpc_method_handler(
          servicer.UpdateEnvironmentCredentials,
          request_deserializer=protectionenvironment__pb2.UpdateEnvironmentCredentialsRequest.FromString,
          response_serializer=protectionenvironment__pb2.UpdateEnvironmentCredentialsResponse.SerializeToString,
      ),
      'GetEnvironmentStatus': grpc.unary_unary_rpc_method_handler(
          servicer.GetEnvironmentStatus,
          request_deserializer=protectionenvironment__pb2.GetEnvironmentStatusRequest.FromString,
          response_serializer=protectionenvironment__pb2.GetEnvironmentStatusResponse.SerializeToString,
      ),
      'UpdateEnvironmentMetadata': grpc.unary_unary_rpc_method_handler(
          servicer.UpdateEnvironmentMetadata,
          request_deserializer=protectionenvironment__pb2.UpdateEnvironmentMetadataRequest.FromString,
          response_serializer=protectionenvironment__pb2.UpdateEnvironmentMetadataResponse.SerializeToString,
      ),
      'GetEnvironmentMetadata': grpc.unary_unary_rpc_method_handler(
          servicer.GetEnvironmentMetadata,
          request_deserializer=protectionenvironment__pb2.GetEnvironmentMetadataRequest.FromString,
          response_serializer=protectionenvironment__pb2.GetEnvironmentMetadataResponse.SerializeToString,
      ),
      'GetExternalToken': grpc.unary_unary_rpc_method_handler(
          servicer.GetExternalToken,
          request_deserializer=protectionenvironment__pb2.GetExternalTokenRequest.FromString,
          response_serializer=protectionenvironment__pb2.GetExternalTokenResponse.SerializeToString,
      ),
      'ListResources': grpc.unary_stream_rpc_method_handler(
          servicer.ListResources,
          request_deserializer=protectionenvironment__pb2.ListResourcesRequest.FromString,
          response_serializer=protectionenvironment__pb2.ListResourcesResponse.SerializeToString,
      ),
      'AddStorage': grpc.unary_stream_rpc_method_handler(
          servicer.AddStorage,
          request_deserializer=protectionenvironment__pb2.AddStorageRequest.FromString,
          response_serializer=protectionenvironment__pb2.AddStorageResponse.SerializeToString,
      ),
      'ListStorage': grpc.unary_stream_rpc_method_handler(
          servicer.ListStorage,
          request_deserializer=protectionenvironment__pb2.ListStorageRequest.FromString,
          response_serializer=protectionenvironment__pb2.ListStorageResponse.SerializeToString,
      ),
  }
  generic_handler = grpc.method_handlers_generic_handler(
      'stc.proto.protectionenvironment.azure.ProtectionEnvironment', rpc_method_handlers)
  server.add_generic_rpc_handlers((generic_handler,))
