# Generated by the Protocol Buffers compiler. DO NOT EDIT!
# source: replication.proto
# plugin: grpclib.plugin.main
import abc
import typing

import grpclib.const
import grpclib.client
if typing.TYPE_CHECKING:
    import grpclib.server

from . import common_pb2
from . import job_pb2
from . import storage_pb2
from . import retention_pb2
from . import replication_pb2


class ReplicationBase(abc.ABC):

    @abc.abstractmethod
    async def Replicate(self, stream: 'grpclib.server.Stream[replication_pb2.StartRequest, job_pb2.Job]') -> None:
        pass

    @abc.abstractmethod
    async def Start(self, stream: 'grpclib.server.Stream[replication_pb2.StartRequest, replication_pb2.StartResponse]') -> None:
        pass

    @abc.abstractmethod
    async def List(self, stream: 'grpclib.server.Stream[replication_pb2.ListRequest, replication_pb2.ListResponse]') -> None:
        pass

    @abc.abstractmethod
    async def Query(self, stream: 'grpclib.server.Stream[replication_pb2.QueryRequest, replication_pb2.QueryResponse]') -> None:
        pass

    @abc.abstractmethod
    async def Update(self, stream: 'grpclib.server.Stream[replication_pb2.UpdateRequest, replication_pb2.UpdateResponse]') -> None:
        pass

    @abc.abstractmethod
    async def Cancel(self, stream: 'grpclib.server.Stream[replication_pb2.CancelRequest, replication_pb2.CancelResponse]') -> None:
        pass

    @abc.abstractmethod
    async def GetStatus(self, stream: 'grpclib.server.Stream[replication_pb2.GetStatusRequest, replication_pb2.GetStatusResponse]') -> None:
        pass

    @abc.abstractmethod
    async def GetConfig(self, stream: 'grpclib.server.Stream[replication_pb2.GetConfigRequest, replication_pb2.GetConfigResponse]') -> None:
        pass

    @abc.abstractmethod
    async def SetConfig(self, stream: 'grpclib.server.Stream[replication_pb2.SetConfigRequest, replication_pb2.SetConfigResponse]') -> None:
        pass

    @abc.abstractmethod
    async def Check(self, stream: 'grpclib.server.Stream[common_pb2.HealthCheckRequest, common_pb2.HealthCheckResponse]') -> None:
        pass

    def __mapping__(self) -> typing.Dict[str, grpclib.const.Handler]:
        return {
            '/stc.proto.replication.Replication/Replicate': grpclib.const.Handler(
                self.Replicate,
                grpclib.const.Cardinality.UNARY_STREAM,
                replication_pb2.StartRequest,
                job_pb2.Job,
            ),
            '/stc.proto.replication.Replication/Start': grpclib.const.Handler(
                self.Start,
                grpclib.const.Cardinality.UNARY_UNARY,
                replication_pb2.StartRequest,
                replication_pb2.StartResponse,
            ),
            '/stc.proto.replication.Replication/List': grpclib.const.Handler(
                self.List,
                grpclib.const.Cardinality.UNARY_UNARY,
                replication_pb2.ListRequest,
                replication_pb2.ListResponse,
            ),
            '/stc.proto.replication.Replication/Query': grpclib.const.Handler(
                self.Query,
                grpclib.const.Cardinality.UNARY_UNARY,
                replication_pb2.QueryRequest,
                replication_pb2.QueryResponse,
            ),
            '/stc.proto.replication.Replication/Update': grpclib.const.Handler(
                self.Update,
                grpclib.const.Cardinality.UNARY_UNARY,
                replication_pb2.UpdateRequest,
                replication_pb2.UpdateResponse,
            ),
            '/stc.proto.replication.Replication/Cancel': grpclib.const.Handler(
                self.Cancel,
                grpclib.const.Cardinality.UNARY_UNARY,
                replication_pb2.CancelRequest,
                replication_pb2.CancelResponse,
            ),
            '/stc.proto.replication.Replication/GetStatus': grpclib.const.Handler(
                self.GetStatus,
                grpclib.const.Cardinality.UNARY_UNARY,
                replication_pb2.GetStatusRequest,
                replication_pb2.GetStatusResponse,
            ),
            '/stc.proto.replication.Replication/GetConfig': grpclib.const.Handler(
                self.GetConfig,
                grpclib.const.Cardinality.UNARY_UNARY,
                replication_pb2.GetConfigRequest,
                replication_pb2.GetConfigResponse,
            ),
            '/stc.proto.replication.Replication/SetConfig': grpclib.const.Handler(
                self.SetConfig,
                grpclib.const.Cardinality.UNARY_UNARY,
                replication_pb2.SetConfigRequest,
                replication_pb2.SetConfigResponse,
            ),
            '/stc.proto.replication.Replication/Check': grpclib.const.Handler(
                self.Check,
                grpclib.const.Cardinality.UNARY_UNARY,
                common_pb2.HealthCheckRequest,
                common_pb2.HealthCheckResponse,
            ),
        }


class ReplicationStub:

    def __init__(self, channel: grpclib.client.Channel) -> None:
        self.Replicate = grpclib.client.UnaryStreamMethod(
            channel,
            '/stc.proto.replication.Replication/Replicate',
            replication_pb2.StartRequest,
            job_pb2.Job,
        )
        self.Start = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.replication.Replication/Start',
            replication_pb2.StartRequest,
            replication_pb2.StartResponse,
        )
        self.List = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.replication.Replication/List',
            replication_pb2.ListRequest,
            replication_pb2.ListResponse,
        )
        self.Query = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.replication.Replication/Query',
            replication_pb2.QueryRequest,
            replication_pb2.QueryResponse,
        )
        self.Update = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.replication.Replication/Update',
            replication_pb2.UpdateRequest,
            replication_pb2.UpdateResponse,
        )
        self.Cancel = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.replication.Replication/Cancel',
            replication_pb2.CancelRequest,
            replication_pb2.CancelResponse,
        )
        self.GetStatus = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.replication.Replication/GetStatus',
            replication_pb2.GetStatusRequest,
            replication_pb2.GetStatusResponse,
        )
        self.GetConfig = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.replication.Replication/GetConfig',
            replication_pb2.GetConfigRequest,
            replication_pb2.GetConfigResponse,
        )
        self.SetConfig = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.replication.Replication/SetConfig',
            replication_pb2.SetConfigRequest,
            replication_pb2.SetConfigResponse,
        )
        self.Check = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.replication.Replication/Check',
            common_pb2.HealthCheckRequest,
            common_pb2.HealthCheckResponse,
        )
