# Generated by the Protocol Buffers compiler. DO NOT EDIT!
# source: storage.proto
# plugin: grpclib.plugin.main
import abc
import typing

import grpclib.const
import grpclib.client
if typing.TYPE_CHECKING:
    import grpclib.server

from . import common_pb2
from . import storageencoding_pb2
from . import storageencryption_pb2
import google.protobuf.any_pb2
from . import storage_pb2


class StorageBase(abc.ABC):

    @abc.abstractmethod
    async def Create(self, stream: 'grpclib.server.Stream[storage_pb2.CreateRequest, storage_pb2.CreateResponse]') -> None:
        pass

    @abc.abstractmethod
    async def Delete(self, stream: 'grpclib.server.Stream[storage_pb2.DeleteRequest, storage_pb2.DeleteResponse]') -> None:
        pass

    @abc.abstractmethod
    async def Query(self, stream: 'grpclib.server.Stream[storage_pb2.QueryRequest, storage_pb2.QueryResponse]') -> None:
        pass

    @abc.abstractmethod
    async def Write(self, stream: 'grpclib.server.Stream[storage_pb2.WriteRequest, storage_pb2.WriteResponse]') -> None:
        pass

    @abc.abstractmethod
    async def Read(self, stream: 'grpclib.server.Stream[storage_pb2.ReadRequest, storage_pb2.ReadResponse]') -> None:
        pass

    @abc.abstractmethod
    async def WriteBlocks(self, stream: 'grpclib.server.Stream[storage_pb2.WriteBlocksRequest, storage_pb2.WriteResponse]') -> None:
        pass

    @abc.abstractmethod
    async def ReadBlocks(self, stream: 'grpclib.server.Stream[storage_pb2.ReadBlocksRequest, storage_pb2.ReadBlocksResponse]') -> None:
        pass

    @abc.abstractmethod
    async def Verify(self, stream: 'grpclib.server.Stream[storage_pb2.VerifyRequest, storage_pb2.VerifyResponse]') -> None:
        pass

    @abc.abstractmethod
    async def ListExtents(self, stream: 'grpclib.server.Stream[storage_pb2.ListExtentsRequest, storage_pb2.ListExtentsResponse]') -> None:
        pass

    @abc.abstractmethod
    async def GetSize(self, stream: 'grpclib.server.Stream[storage_pb2.GetSizeRequest, storage_pb2.GetSizeResponse]') -> None:
        pass

    @abc.abstractmethod
    async def GetConfig(self, stream: 'grpclib.server.Stream[storage_pb2.GetConfigRequest, storage_pb2.GetConfigResponse]') -> None:
        pass

    @abc.abstractmethod
    async def SetConfig(self, stream: 'grpclib.server.Stream[storage_pb2.SetConfigRequest, storage_pb2.SetConfigResponse]') -> None:
        pass

    @abc.abstractmethod
    async def GetStatus(self, stream: 'grpclib.server.Stream[storage_pb2.GetStatusRequest, storage_pb2.GetStatusResponse]') -> None:
        pass

    @abc.abstractmethod
    async def Check(self, stream: 'grpclib.server.Stream[common_pb2.HealthCheckRequest, common_pb2.HealthCheckResponse]') -> None:
        pass

    def __mapping__(self) -> typing.Dict[str, grpclib.const.Handler]:
        return {
            '/stc.proto.storage.Storage/Create': grpclib.const.Handler(
                self.Create,
                grpclib.const.Cardinality.UNARY_UNARY,
                storage_pb2.CreateRequest,
                storage_pb2.CreateResponse,
            ),
            '/stc.proto.storage.Storage/Delete': grpclib.const.Handler(
                self.Delete,
                grpclib.const.Cardinality.UNARY_UNARY,
                storage_pb2.DeleteRequest,
                storage_pb2.DeleteResponse,
            ),
            '/stc.proto.storage.Storage/Query': grpclib.const.Handler(
                self.Query,
                grpclib.const.Cardinality.UNARY_UNARY,
                storage_pb2.QueryRequest,
                storage_pb2.QueryResponse,
            ),
            '/stc.proto.storage.Storage/Write': grpclib.const.Handler(
                self.Write,
                grpclib.const.Cardinality.STREAM_STREAM,
                storage_pb2.WriteRequest,
                storage_pb2.WriteResponse,
            ),
            '/stc.proto.storage.Storage/Read': grpclib.const.Handler(
                self.Read,
                grpclib.const.Cardinality.UNARY_STREAM,
                storage_pb2.ReadRequest,
                storage_pb2.ReadResponse,
            ),
            '/stc.proto.storage.Storage/WriteBlocks': grpclib.const.Handler(
                self.WriteBlocks,
                grpclib.const.Cardinality.STREAM_STREAM,
                storage_pb2.WriteBlocksRequest,
                storage_pb2.WriteResponse,
            ),
            '/stc.proto.storage.Storage/ReadBlocks': grpclib.const.Handler(
                self.ReadBlocks,
                grpclib.const.Cardinality.UNARY_STREAM,
                storage_pb2.ReadBlocksRequest,
                storage_pb2.ReadBlocksResponse,
            ),
            '/stc.proto.storage.Storage/Verify': grpclib.const.Handler(
                self.Verify,
                grpclib.const.Cardinality.UNARY_STREAM,
                storage_pb2.VerifyRequest,
                storage_pb2.VerifyResponse,
            ),
            '/stc.proto.storage.Storage/ListExtents': grpclib.const.Handler(
                self.ListExtents,
                grpclib.const.Cardinality.UNARY_STREAM,
                storage_pb2.ListExtentsRequest,
                storage_pb2.ListExtentsResponse,
            ),
            '/stc.proto.storage.Storage/GetSize': grpclib.const.Handler(
                self.GetSize,
                grpclib.const.Cardinality.UNARY_UNARY,
                storage_pb2.GetSizeRequest,
                storage_pb2.GetSizeResponse,
            ),
            '/stc.proto.storage.Storage/GetConfig': grpclib.const.Handler(
                self.GetConfig,
                grpclib.const.Cardinality.UNARY_UNARY,
                storage_pb2.GetConfigRequest,
                storage_pb2.GetConfigResponse,
            ),
            '/stc.proto.storage.Storage/SetConfig': grpclib.const.Handler(
                self.SetConfig,
                grpclib.const.Cardinality.UNARY_UNARY,
                storage_pb2.SetConfigRequest,
                storage_pb2.SetConfigResponse,
            ),
            '/stc.proto.storage.Storage/GetStatus': grpclib.const.Handler(
                self.GetStatus,
                grpclib.const.Cardinality.UNARY_UNARY,
                storage_pb2.GetStatusRequest,
                storage_pb2.GetStatusResponse,
            ),
            '/stc.proto.storage.Storage/Check': grpclib.const.Handler(
                self.Check,
                grpclib.const.Cardinality.UNARY_UNARY,
                common_pb2.HealthCheckRequest,
                common_pb2.HealthCheckResponse,
            ),
        }


class StorageStub:

    def __init__(self, channel: grpclib.client.Channel) -> None:
        self.Create = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.storage.Storage/Create',
            storage_pb2.CreateRequest,
            storage_pb2.CreateResponse,
        )
        self.Delete = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.storage.Storage/Delete',
            storage_pb2.DeleteRequest,
            storage_pb2.DeleteResponse,
        )
        self.Query = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.storage.Storage/Query',
            storage_pb2.QueryRequest,
            storage_pb2.QueryResponse,
        )
        self.Write = grpclib.client.StreamStreamMethod(
            channel,
            '/stc.proto.storage.Storage/Write',
            storage_pb2.WriteRequest,
            storage_pb2.WriteResponse,
        )
        self.Read = grpclib.client.UnaryStreamMethod(
            channel,
            '/stc.proto.storage.Storage/Read',
            storage_pb2.ReadRequest,
            storage_pb2.ReadResponse,
        )
        self.WriteBlocks = grpclib.client.StreamStreamMethod(
            channel,
            '/stc.proto.storage.Storage/WriteBlocks',
            storage_pb2.WriteBlocksRequest,
            storage_pb2.WriteResponse,
        )
        self.ReadBlocks = grpclib.client.UnaryStreamMethod(
            channel,
            '/stc.proto.storage.Storage/ReadBlocks',
            storage_pb2.ReadBlocksRequest,
            storage_pb2.ReadBlocksResponse,
        )
        self.Verify = grpclib.client.UnaryStreamMethod(
            channel,
            '/stc.proto.storage.Storage/Verify',
            storage_pb2.VerifyRequest,
            storage_pb2.VerifyResponse,
        )
        self.ListExtents = grpclib.client.UnaryStreamMethod(
            channel,
            '/stc.proto.storage.Storage/ListExtents',
            storage_pb2.ListExtentsRequest,
            storage_pb2.ListExtentsResponse,
        )
        self.GetSize = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.storage.Storage/GetSize',
            storage_pb2.GetSizeRequest,
            storage_pb2.GetSizeResponse,
        )
        self.GetConfig = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.storage.Storage/GetConfig',
            storage_pb2.GetConfigRequest,
            storage_pb2.GetConfigResponse,
        )
        self.SetConfig = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.storage.Storage/SetConfig',
            storage_pb2.SetConfigRequest,
            storage_pb2.SetConfigResponse,
        )
        self.GetStatus = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.storage.Storage/GetStatus',
            storage_pb2.GetStatusRequest,
            storage_pb2.GetStatusResponse,
        )
        self.Check = grpclib.client.UnaryUnaryMethod(
            channel,
            '/stc.proto.storage.Storage/Check',
            common_pb2.HealthCheckRequest,
            common_pb2.HealthCheckResponse,
        )
