# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
import grpc

from . import common_pb2 as common__pb2
from . import storage_pb2 as storage__pb2


class StorageStub(object):
  """Notable responses for Create/Delete/Query/Read/Write:
  DATA_CORRUPTION
  Data or metadata corruption was detected via hash mismatch or via
  unparsable or unexpected values.  Subsequent incrementals may mask
  the problem, or self-healing (future) may fix it.
  This is _not_ indicative of a broken chain.
  Usually not worth retrying.
  STORAGE_IO_ERROR
  Error from the underlying storage.  May or may not be transient.

  """

  def __init__(self, channel):
    """Constructor.

    Args:
      channel: A grpc.Channel.
    """
    self.Create = channel.unary_unary(
        '/stc.proto.storage.Storage/Create',
        request_serializer=storage__pb2.CreateRequest.SerializeToString,
        response_deserializer=storage__pb2.CreateResponse.FromString,
        )
    self.Delete = channel.unary_unary(
        '/stc.proto.storage.Storage/Delete',
        request_serializer=storage__pb2.DeleteRequest.SerializeToString,
        response_deserializer=storage__pb2.DeleteResponse.FromString,
        )
    self.Query = channel.unary_unary(
        '/stc.proto.storage.Storage/Query',
        request_serializer=storage__pb2.QueryRequest.SerializeToString,
        response_deserializer=storage__pb2.QueryResponse.FromString,
        )
    self.Write = channel.stream_stream(
        '/stc.proto.storage.Storage/Write',
        request_serializer=storage__pb2.WriteRequest.SerializeToString,
        response_deserializer=storage__pb2.WriteResponse.FromString,
        )
    self.Read = channel.unary_stream(
        '/stc.proto.storage.Storage/Read',
        request_serializer=storage__pb2.ReadRequest.SerializeToString,
        response_deserializer=storage__pb2.ReadResponse.FromString,
        )
    self.WriteBlocks = channel.stream_stream(
        '/stc.proto.storage.Storage/WriteBlocks',
        request_serializer=storage__pb2.WriteBlocksRequest.SerializeToString,
        response_deserializer=storage__pb2.WriteResponse.FromString,
        )
    self.ReadBlocks = channel.unary_stream(
        '/stc.proto.storage.Storage/ReadBlocks',
        request_serializer=storage__pb2.ReadBlocksRequest.SerializeToString,
        response_deserializer=storage__pb2.ReadBlocksResponse.FromString,
        )
    self.Verify = channel.unary_stream(
        '/stc.proto.storage.Storage/Verify',
        request_serializer=storage__pb2.VerifyRequest.SerializeToString,
        response_deserializer=storage__pb2.VerifyResponse.FromString,
        )
    self.ListExtents = channel.unary_stream(
        '/stc.proto.storage.Storage/ListExtents',
        request_serializer=storage__pb2.ListExtentsRequest.SerializeToString,
        response_deserializer=storage__pb2.ListExtentsResponse.FromString,
        )
    self.GetSize = channel.unary_unary(
        '/stc.proto.storage.Storage/GetSize',
        request_serializer=storage__pb2.GetSizeRequest.SerializeToString,
        response_deserializer=storage__pb2.GetSizeResponse.FromString,
        )
    self.GetConfig = channel.unary_unary(
        '/stc.proto.storage.Storage/GetConfig',
        request_serializer=storage__pb2.GetConfigRequest.SerializeToString,
        response_deserializer=storage__pb2.GetConfigResponse.FromString,
        )
    self.SetConfig = channel.unary_unary(
        '/stc.proto.storage.Storage/SetConfig',
        request_serializer=storage__pb2.SetConfigRequest.SerializeToString,
        response_deserializer=storage__pb2.SetConfigResponse.FromString,
        )
    self.GetStatus = channel.unary_unary(
        '/stc.proto.storage.Storage/GetStatus',
        request_serializer=storage__pb2.GetStatusRequest.SerializeToString,
        response_deserializer=storage__pb2.GetStatusResponse.FromString,
        )
    self.Check = channel.unary_unary(
        '/stc.proto.storage.Storage/Check',
        request_serializer=common__pb2.HealthCheckRequest.SerializeToString,
        response_deserializer=common__pb2.HealthCheckResponse.FromString,
        )


class StorageServicer(object):
  """Notable responses for Create/Delete/Query/Read/Write:
  DATA_CORRUPTION
  Data or metadata corruption was detected via hash mismatch or via
  unparsable or unexpected values.  Subsequent incrementals may mask
  the problem, or self-healing (future) may fix it.
  This is _not_ indicative of a broken chain.
  Usually not worth retrying.
  STORAGE_IO_ERROR
  Error from the underlying storage.  May or may not be transient.

  """

  def Create(self, request, context):
    """Creates a new mutable image, optionally inheriting data from a parent
    image (which must be immutable).  The image's size must be declared
    during creation, but the size may differ from the parent image's
    size.  The image is write-only, until it is fully written and/or put in
    a recovery point, at which point it becomes immutable and read-only.

    Notable responses:
    OK
    Image created or resumed (see last_image_offset to distinguish)
    EXISTS
    The immutable image already exists
    IMAGE_NOT_FOUND
    The requested parent does not exist
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def Delete(self, request, context):
    """Delete an image from the storage.  Will fail if the image is immutable.
    Images are automatically deleted when the last reference is dropped.
    In practice this call is only used to abort a previous Create call, and
    will be deprecated as reference counting is improved.

    Notable responses:
    OK
    Deleted (ID removed from namespace but space reclamation may be async)
    READ_ONLY
    Image is immutable; manage by create/delete point instead
    IMAGE_NOT_FOUND
    The image does not exist
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def Query(self, request, context):
    """Query the storage service about a specific image.

    Notable responses:
    OK
    Image exists (may be mutable or immutable)
    IMAGE_NOT_FOUND
    The image does not exist
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def Write(self, request_iterator, context):
    """Writes to a mutable image.  The write must entirely fit within the size
    declared when the image was created.  Writes must be forward-only and
    contiguous but may be sparse.  The first streaming write should be limited
    to a single chunk.  Subsequent writes should limit themselves to the sizes
    advertised in the responses.
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def Read(self, request, context):
    """Reads from an immutable image.  Reads of unwritten ranges will not be covered
    by any extents if the image has no parent or the parent does not cover the
    range; otherwise, the parent's data is returned for the unwritten ranges.
    Reads only return extents (possibly truncated) that fit within the requested
    range.  Reads of "large" ranges are supported; the responses will be chunked.
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def WriteBlocks(self, request_iterator, context):
    """Similar to Write, but block-aligned.  Blocks may be written cleartext or
    already compressed and encrypted.
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def ReadBlocks(self, request, context):
    """Similar to Read, but block-aligned.  Blocks may be read cleartext or
    still compressed and encrypted.
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def Verify(self, request, context):
    """Verifies data on a storage node.
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def ListExtents(self, request, context):
    """Queries extents of an immutable image.  This returns the extents (offset
    and length) where data is present, but (unlike the Read request) not the
    actual data.
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def GetSize(self, request, context):
    """Queries extents of an immutable image.  This returns the only
    the size of the extents
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def GetConfig(self, request, context):
    # missing associated documentation comment in .proto file
    pass
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def SetConfig(self, request, context):
    # missing associated documentation comment in .proto file
    pass
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def GetStatus(self, request, context):
    # missing associated documentation comment in .proto file
    pass
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def Check(self, request, context):
    # missing associated documentation comment in .proto file
    pass
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')


def add_StorageServicer_to_server(servicer, server):
  rpc_method_handlers = {
      'Create': grpc.unary_unary_rpc_method_handler(
          servicer.Create,
          request_deserializer=storage__pb2.CreateRequest.FromString,
          response_serializer=storage__pb2.CreateResponse.SerializeToString,
      ),
      'Delete': grpc.unary_unary_rpc_method_handler(
          servicer.Delete,
          request_deserializer=storage__pb2.DeleteRequest.FromString,
          response_serializer=storage__pb2.DeleteResponse.SerializeToString,
      ),
      'Query': grpc.unary_unary_rpc_method_handler(
          servicer.Query,
          request_deserializer=storage__pb2.QueryRequest.FromString,
          response_serializer=storage__pb2.QueryResponse.SerializeToString,
      ),
      'Write': grpc.stream_stream_rpc_method_handler(
          servicer.Write,
          request_deserializer=storage__pb2.WriteRequest.FromString,
          response_serializer=storage__pb2.WriteResponse.SerializeToString,
      ),
      'Read': grpc.unary_stream_rpc_method_handler(
          servicer.Read,
          request_deserializer=storage__pb2.ReadRequest.FromString,
          response_serializer=storage__pb2.ReadResponse.SerializeToString,
      ),
      'WriteBlocks': grpc.stream_stream_rpc_method_handler(
          servicer.WriteBlocks,
          request_deserializer=storage__pb2.WriteBlocksRequest.FromString,
          response_serializer=storage__pb2.WriteResponse.SerializeToString,
      ),
      'ReadBlocks': grpc.unary_stream_rpc_method_handler(
          servicer.ReadBlocks,
          request_deserializer=storage__pb2.ReadBlocksRequest.FromString,
          response_serializer=storage__pb2.ReadBlocksResponse.SerializeToString,
      ),
      'Verify': grpc.unary_stream_rpc_method_handler(
          servicer.Verify,
          request_deserializer=storage__pb2.VerifyRequest.FromString,
          response_serializer=storage__pb2.VerifyResponse.SerializeToString,
      ),
      'ListExtents': grpc.unary_stream_rpc_method_handler(
          servicer.ListExtents,
          request_deserializer=storage__pb2.ListExtentsRequest.FromString,
          response_serializer=storage__pb2.ListExtentsResponse.SerializeToString,
      ),
      'GetSize': grpc.unary_unary_rpc_method_handler(
          servicer.GetSize,
          request_deserializer=storage__pb2.GetSizeRequest.FromString,
          response_serializer=storage__pb2.GetSizeResponse.SerializeToString,
      ),
      'GetConfig': grpc.unary_unary_rpc_method_handler(
          servicer.GetConfig,
          request_deserializer=storage__pb2.GetConfigRequest.FromString,
          response_serializer=storage__pb2.GetConfigResponse.SerializeToString,
      ),
      'SetConfig': grpc.unary_unary_rpc_method_handler(
          servicer.SetConfig,
          request_deserializer=storage__pb2.SetConfigRequest.FromString,
          response_serializer=storage__pb2.SetConfigResponse.SerializeToString,
      ),
      'GetStatus': grpc.unary_unary_rpc_method_handler(
          servicer.GetStatus,
          request_deserializer=storage__pb2.GetStatusRequest.FromString,
          response_serializer=storage__pb2.GetStatusResponse.SerializeToString,
      ),
      'Check': grpc.unary_unary_rpc_method_handler(
          servicer.Check,
          request_deserializer=common__pb2.HealthCheckRequest.FromString,
          response_serializer=common__pb2.HealthCheckResponse.SerializeToString,
      ),
  }
  generic_handler = grpc.method_handlers_generic_handler(
      'stc.proto.storage.Storage', rpc_method_handlers)
  server.add_generic_rpc_handlers((generic_handler,))
