# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
import grpc

from . import vddk_pb2 as vddk__pb2


class VDDKStub(object):
  """
  The VDDK service provides a stateful wrapper around VMware's nasty little API
  for accessing their disks.

  The vddk::Client class will spin one out for you. You aren't expected to run
  the vddk::Service as part of your code; you don't want to. Instead, just create
  a client with the appropriate parameters and it will handle the Service for you.

  Calls to this service are a little different from other gRPC services we do.
  A VDDK session is very stateful; to account for this, we are leveraging the fact
  that a single bidirectional streaming call can hold client and server context on
  the stack for as long as it is underway. Successive IOCtls are issued over the
  same stream in a call-response pattern. Disks are opened, I/O performed, etc.
  When the client connection closes, all associated handles are cleaned up on the
  server side.

  The vddk::Client hides this implementation detail for you as well and looks like
  a mostly regular API.

  NOTE:
  As-written, each client will spawn an entire VDDK service all its own. The service
  listens on a Unix domain socket, rather than TCP. This means that it's local-only.
  Additionally, gRPC serves only as the control channel for this API. The data handling
  for the I/O is done using shared memory, rather than passing the buffers through gRPC.

  We may need to evaluate whether we want to allow persistent VDDK processes for performance
  reasons or because of limitations of the VDDK itself, e.g. the number of active connections.

  """

  def __init__(self, channel):
    """Constructor.

    Args:
      channel: A grpc.Channel.
    """
    self.IOCtl = channel.stream_stream(
        '/stc.proto.vddk.VDDK/IOCtl',
        request_serializer=vddk__pb2.IOCtlRequest.SerializeToString,
        response_deserializer=vddk__pb2.IOCtlResponse.FromString,
        )
    self.Shutdown = channel.unary_unary(
        '/stc.proto.vddk.VDDK/Shutdown',
        request_serializer=vddk__pb2.ShutdownRequest.SerializeToString,
        response_deserializer=vddk__pb2.ShutdownResponse.FromString,
        )
    self.Cleanup = channel.unary_unary(
        '/stc.proto.vddk.VDDK/Cleanup',
        request_serializer=vddk__pb2.PrepareRequest.SerializeToString,
        response_deserializer=vddk__pb2.IOCtlResponse.FromString,
        )


class VDDKServicer(object):
  """
  The VDDK service provides a stateful wrapper around VMware's nasty little API
  for accessing their disks.

  The vddk::Client class will spin one out for you. You aren't expected to run
  the vddk::Service as part of your code; you don't want to. Instead, just create
  a client with the appropriate parameters and it will handle the Service for you.

  Calls to this service are a little different from other gRPC services we do.
  A VDDK session is very stateful; to account for this, we are leveraging the fact
  that a single bidirectional streaming call can hold client and server context on
  the stack for as long as it is underway. Successive IOCtls are issued over the
  same stream in a call-response pattern. Disks are opened, I/O performed, etc.
  When the client connection closes, all associated handles are cleaned up on the
  server side.

  The vddk::Client hides this implementation detail for you as well and looks like
  a mostly regular API.

  NOTE:
  As-written, each client will spawn an entire VDDK service all its own. The service
  listens on a Unix domain socket, rather than TCP. This means that it's local-only.
  Additionally, gRPC serves only as the control channel for this API. The data handling
  for the I/O is done using shared memory, rather than passing the buffers through gRPC.

  We may need to evaluate whether we want to allow persistent VDDK processes for performance
  reasons or because of limitations of the VDDK itself, e.g. the number of active connections.

  """

  def IOCtl(self, request_iterator, context):
    """
    Issue a single command in the context of this VDDK session. A typical session might
    look something like the following:

    1) Prepare
    2) Connect
    3) Open
    4) Read
    5) Read

    ...

    N) Open
    M) Read

    ...

    Resource cleanup will happen automatically when the client object is destructed.
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def Shutdown(self, request, context):
    """
    Raises a SIGINT in the service's process. The Client will call this automatically
    as part of its destruction and shutdown process. If the service doesn't cleanly
    shutdown within 5s, it's forcefully terminated to avoid blocking the client unduly.
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def Cleanup(self, request, context):
    """
    Runs the VDDK cleanup command in a stand-alone instance of the service.
    Used to cleanup stale/dead sessions resulting from deadlocks or other errors.
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')


def add_VDDKServicer_to_server(servicer, server):
  rpc_method_handlers = {
      'IOCtl': grpc.stream_stream_rpc_method_handler(
          servicer.IOCtl,
          request_deserializer=vddk__pb2.IOCtlRequest.FromString,
          response_serializer=vddk__pb2.IOCtlResponse.SerializeToString,
      ),
      'Shutdown': grpc.unary_unary_rpc_method_handler(
          servicer.Shutdown,
          request_deserializer=vddk__pb2.ShutdownRequest.FromString,
          response_serializer=vddk__pb2.ShutdownResponse.SerializeToString,
      ),
      'Cleanup': grpc.unary_unary_rpc_method_handler(
          servicer.Cleanup,
          request_deserializer=vddk__pb2.PrepareRequest.FromString,
          response_serializer=vddk__pb2.IOCtlResponse.SerializeToString,
      ),
  }
  generic_handler = grpc.method_handlers_generic_handler(
      'stc.proto.vddk.VDDK', rpc_method_handlers)
  server.add_generic_rpc_handlers((generic_handler,))
