# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
import grpc

from . import common_pb2 as common__pb2
from . import vfs_pb2 as vfs__pb2


class VFSStub(object):
  """Provides access to the volume and file systems in a backup image.

  This API provides the necessary pieces to build a file/folder recovery tool.
  It is intended to be used to enumerate successive levels of an image and
  then retreive the data of specific files therein.

  Assuming a standard disk with a partition table of some sort, the children
  at the root of an Image will be the partitions themselves. The children of
  those partitions will be files in the file system, etc.

  Because this accesses the file systems from the very lowest layer, it will
  expose everything that file system supports. That means that hidden, system,
  and otherwise special files will come back as children. It is up to the
  callers of this service whether or not to filter them out.
  """

  def __init__(self, channel):
    """Constructor.

    Args:
      channel: A grpc.Channel.
    """
    self.List = channel.unary_unary(
        '/stc.proto.vfs.VFS/List',
        request_serializer=vfs__pb2.ListRequest.SerializeToString,
        response_deserializer=vfs__pb2.ListResponse.FromString,
        )
    self.Query = channel.unary_unary(
        '/stc.proto.vfs.VFS/Query',
        request_serializer=vfs__pb2.QueryRequest.SerializeToString,
        response_deserializer=vfs__pb2.QueryResponse.FromString,
        )
    self.Read = channel.unary_stream(
        '/stc.proto.vfs.VFS/Read',
        request_serializer=vfs__pb2.ReadRequest.SerializeToString,
        response_deserializer=vfs__pb2.ReadResponse.FromString,
        )
    self.Check = channel.unary_unary(
        '/stc.proto.vfs.VFS/Check',
        request_serializer=common__pb2.HealthCheckRequest.SerializeToString,
        response_deserializer=common__pb2.HealthCheckResponse.FromString,
        )


class VFSServicer(object):
  """Provides access to the volume and file systems in a backup image.

  This API provides the necessary pieces to build a file/folder recovery tool.
  It is intended to be used to enumerate successive levels of an image and
  then retreive the data of specific files therein.

  Assuming a standard disk with a partition table of some sort, the children
  at the root of an Image will be the partitions themselves. The children of
  those partitions will be files in the file system, etc.

  Because this accesses the file systems from the very lowest layer, it will
  expose everything that file system supports. That means that hidden, system,
  and otherwise special files will come back as children. It is up to the
  callers of this service whether or not to filter them out.
  """

  def List(self, request, context):
    """List the contents of a directory-ish inside an image.
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def Query(self, request, context):
    """Stat a path inside an image.
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def Read(self, request, context):
    """Stream a file out an image.
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def Check(self, request, context):
    # missing associated documentation comment in .proto file
    pass
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')


def add_VFSServicer_to_server(servicer, server):
  rpc_method_handlers = {
      'List': grpc.unary_unary_rpc_method_handler(
          servicer.List,
          request_deserializer=vfs__pb2.ListRequest.FromString,
          response_serializer=vfs__pb2.ListResponse.SerializeToString,
      ),
      'Query': grpc.unary_unary_rpc_method_handler(
          servicer.Query,
          request_deserializer=vfs__pb2.QueryRequest.FromString,
          response_serializer=vfs__pb2.QueryResponse.SerializeToString,
      ),
      'Read': grpc.unary_stream_rpc_method_handler(
          servicer.Read,
          request_deserializer=vfs__pb2.ReadRequest.FromString,
          response_serializer=vfs__pb2.ReadResponse.SerializeToString,
      ),
      'Check': grpc.unary_unary_rpc_method_handler(
          servicer.Check,
          request_deserializer=common__pb2.HealthCheckRequest.FromString,
          response_serializer=common__pb2.HealthCheckResponse.SerializeToString,
      ),
  }
  generic_handler = grpc.method_handlers_generic_handler(
      'stc.proto.vfs.VFS', rpc_method_handlers)
  server.add_generic_rpc_handlers((generic_handler,))
